<?php 
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class RelLogControleDeAcessoReportHandler extends AReportHandler {
    const RELATORIO = 'vnd62000_relLogControleDeAcessoExport';
    
    public function buildNewRequest($request, Response $response) {
        
        $conditions = $this->relService->getParamsAsArray($request);
        $conditions = $this->buildParams($conditions);
        
        /*
        $this->relService->setTCDandCDChangingKey($conditions, 'CDLOJA', 'CDLOJA');
        $this->relService->setTCDandCDChangingKey($conditions, 'CDTIPOCONS', 'CDTIPOCONS');
        
        if(!array_key_exists('MODALIDADE', $conditions)) {
            $conditions['TMODALIDADE'] = 'T';
            $conditions['MODALIDADE'] = '';
        } else {
            $conditions['MODALIDADE'] = implode('_', $conditions['MODALIDADE']);
            $conditions['TMODALIDADE'] = 'E';
        }
        
        if(!array_key_exists('CDFILIAL', $conditions)) {
            $conditions['CDFILIAL'] = '';
        } else {
            $this->relService->setTCDandCDChangingKey($conditions, 'CDFILIAL', 'CDFILIAL');
            $conditions['CDOPERADOR'] = '';
        }
        
        $this->relService->setIntervalAsDTINIandDTFIM($conditions, 'DTENTRVENDA', 'DATAINI', 'DATAFIN');
        
        $conditions['FLAGBALTAA'] = 'N';
        $conditions['FLAGBALTAA'] = (strpos($conditions['MODALIDADE'], 'BAL') !== false ? (strpos($conditions['MODALIDADE'], 'TAA') !== false ? 'N' : 'S') : 'N');*/
        
        $newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, self::RELATORIO, $conditions);
        
        return [$newRequest, $response];
    }
    
    public function buildParams($conditions) {
        if(!isset($conditions['CDFILIAL'])) {
            $conditions['CDFILIAL'] = '';
        } else {
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            $conditions['CDOPERADOR'] = '';
        }
        
        if(!isset($conditions['CDCAIXA'])) {
            $conditions['CDCAIXA'] = '';
            $conditions['TCDCAIXA'] = 'T';
        } else {
            $conditions['CDCAIXA'] = implode('_', $conditions['CDCAIXA']);
            $conditions['TCDCAIXA'] = '';
        }
        
        if(!isset($conditions['IDOPERFOS'])) {
            $conditions['IDOPERFOS'] = '';
            $conditions['TIDOPERFOS'] = 'T';
        } else {
            $conditions['IDOPERFOS'] = implode('_', $conditions['IDOPERFOS']);
            $conditions['TIDOPERFOS'] = '';
        }
        
        if(isset($conditions['DTDIA'])) {
            $conditions['DATAINI'] = $conditions['DTDIA'][0];
            $conditions['DATAFIN'] = $conditions['DTDIA'][1];
            unset($conditions['DTDIA']);
        }
        
        return $conditions;
    }
}